#pragma once
#include "B4RDefines.h"

//~dependson: <NewPing.h>

namespace B4R {

//~Version: 1.00
//~ShortName: NewPing
//~Author - Wrapped by Johan Schoeman. Arduino library by Tim Eckel

	class B4RNewPing {
		private:
			uint8_t backend[sizeof(NewPing)];
		public:
			//~hide
			NewPing* np;
			/**
			*Initializes the object.
			*Example:
	        *Dim dst As UInt = 500
            *Dim np As NewPing
	        *Dim pin9 As Byte = 9
	        *Dim pin10 As Byte = 10
            *np.Initialize(TrigPin, EchoPin, maxcmdistance)
			*/
			void Initialize(Byte triggerpin, Byte echopin, UInt maxcmdistance);
			/**
			*Call the ping method and returns the distance in centimeters (no rounding).
			*/
			ULong ping_cm(UInt maxcmdistance);
			/**
			*Call the ping method and returns the distance in inches (no rounding).
			*/
			ULong ping_in(UInt maxcmdistance);	
			/**
			*Do multiple pings (default=5), discard out of range pings and return median in microseconds. [max_cm_distance] allows you to optionally set a new max distance.
			*/			
			ULong ping_median(Byte iterations, UInt maxcmdistance);
			/**
			*Convert uS to centimeters (no rounding).
			*/			
			UInt convert_cm(UInt microseconds);			
			/**
			*Convert uS to inches (no rounding).
			*/			
			UInt convert_in(UInt microseconds);					



			
	};
}
